/*
CVE Services API

The CVE Services API supports automation tooling for the CVE Program. Credentials are     required for most service endpoints. Representatives of     <a href='https://www.cve.org/ProgramOrganization/CNAs'>CVE Numbering Authorities (CNAs)</a> should     use one of the methods below to obtain credentials:    <ul><li>If your organization already has an Organizational Administrator (OA) account for the CVE     Services, ask your admin for credentials</li>     <li>Contact your Root (<a href='https://www.cve.org/PartnerInformation/ListofPartners/partner/Google'>Google</a>,     <a href='https://www.cve.org/PartnerInformation/ListofPartners/partner/INCIBE'>INCIBE</a>,     <a href='https://www.cve.org/PartnerInformation/ListofPartners/partner/jpcert'>JPCERT/CC</a>, or     <a href='https://www.cve.org/PartnerInformation/ListofPartners/partner/redhat'>Red Hat</a>) or     Top-Level Root (<a href='https://www.cve.org/PartnerInformation/ListofPartners/partner/icscert'>CISA ICS</a>     or <a href='https://www.cve.org/PartnerInformation/ListofPartners/partner/mitre'>MITRE</a>) to request credentials     </ul>     <p>CVE data is to be in the JSON 5.0 CVE Record format. Details of the JSON 5.0 schema are     located <a href='https://github.com/CVEProject/cve-schema/tree/master/schema/v5.0' target='_blank'>here</a>.</p>    <a href='https://cveform.mitre.org/' class='link' target='_blank'>Contact the CVE Services team</a>

API version: 2.1.4
*/

// Code generated by OpenAPI Generator (https://openapi-generator.tech); DO NOT EDIT.

package cveapi

import (
	"encoding/json"
)

// checks if the CveRecordMinimumRequestCnaContainer type satisfies the MappedNullable interface at compile time
var _ MappedNullable = &CveRecordMinimumRequestCnaContainer{}

// CveRecordMinimumRequestCnaContainer struct for CveRecordMinimumRequestCnaContainer
type CveRecordMinimumRequestCnaContainer struct {
	Affected []CreateFullCveRecordRequestContainersCnaAffectedInner `json:"affected"`
	Descriptions []GetCveRecordResponseContainersCnaDescriptionsInner `json:"descriptions"`
	ProblemTypes []GetCveRecordResponseContainersCnaProblemTypesInner `json:"problemTypes,omitempty"`
	ProviderMetadata *GetCveRecordResponseContainersCnaProviderMetadata `json:"providerMetadata,omitempty"`
	References []GetCveRecordResponseContainersCnaReferencesInner `json:"references"`
}

// NewCveRecordMinimumRequestCnaContainer instantiates a new CveRecordMinimumRequestCnaContainer object
// This constructor will assign default values to properties that have it defined,
// and makes sure properties required by API are set, but the set of arguments
// will change when the set of required properties is changed
func NewCveRecordMinimumRequestCnaContainer(affected []CreateFullCveRecordRequestContainersCnaAffectedInner, descriptions []GetCveRecordResponseContainersCnaDescriptionsInner, references []GetCveRecordResponseContainersCnaReferencesInner) *CveRecordMinimumRequestCnaContainer {
	this := CveRecordMinimumRequestCnaContainer{}
	this.Affected = affected
	this.Descriptions = descriptions
	this.References = references
	return &this
}

// NewCveRecordMinimumRequestCnaContainerWithDefaults instantiates a new CveRecordMinimumRequestCnaContainer object
// This constructor will only assign default values to properties that have it defined,
// but it doesn't guarantee that properties required by API are set
func NewCveRecordMinimumRequestCnaContainerWithDefaults() *CveRecordMinimumRequestCnaContainer {
	this := CveRecordMinimumRequestCnaContainer{}
	return &this
}

// GetAffected returns the Affected field value
func (o *CveRecordMinimumRequestCnaContainer) GetAffected() []CreateFullCveRecordRequestContainersCnaAffectedInner {
	if o == nil {
		var ret []CreateFullCveRecordRequestContainersCnaAffectedInner
		return ret
	}

	return o.Affected
}

// GetAffectedOk returns a tuple with the Affected field value
// and a boolean to check if the value has been set.
func (o *CveRecordMinimumRequestCnaContainer) GetAffectedOk() ([]CreateFullCveRecordRequestContainersCnaAffectedInner, bool) {
	if o == nil {
		return nil, false
	}
	return o.Affected, true
}

// SetAffected sets field value
func (o *CveRecordMinimumRequestCnaContainer) SetAffected(v []CreateFullCveRecordRequestContainersCnaAffectedInner) {
	o.Affected = v
}

// GetDescriptions returns the Descriptions field value
func (o *CveRecordMinimumRequestCnaContainer) GetDescriptions() []GetCveRecordResponseContainersCnaDescriptionsInner {
	if o == nil {
		var ret []GetCveRecordResponseContainersCnaDescriptionsInner
		return ret
	}

	return o.Descriptions
}

// GetDescriptionsOk returns a tuple with the Descriptions field value
// and a boolean to check if the value has been set.
func (o *CveRecordMinimumRequestCnaContainer) GetDescriptionsOk() ([]GetCveRecordResponseContainersCnaDescriptionsInner, bool) {
	if o == nil {
		return nil, false
	}
	return o.Descriptions, true
}

// SetDescriptions sets field value
func (o *CveRecordMinimumRequestCnaContainer) SetDescriptions(v []GetCveRecordResponseContainersCnaDescriptionsInner) {
	o.Descriptions = v
}

// GetProblemTypes returns the ProblemTypes field value if set, zero value otherwise.
func (o *CveRecordMinimumRequestCnaContainer) GetProblemTypes() []GetCveRecordResponseContainersCnaProblemTypesInner {
	if o == nil || IsNil(o.ProblemTypes) {
		var ret []GetCveRecordResponseContainersCnaProblemTypesInner
		return ret
	}
	return o.ProblemTypes
}

// GetProblemTypesOk returns a tuple with the ProblemTypes field value if set, nil otherwise
// and a boolean to check if the value has been set.
func (o *CveRecordMinimumRequestCnaContainer) GetProblemTypesOk() ([]GetCveRecordResponseContainersCnaProblemTypesInner, bool) {
	if o == nil || IsNil(o.ProblemTypes) {
		return nil, false
	}
	return o.ProblemTypes, true
}

// HasProblemTypes returns a boolean if a field has been set.
func (o *CveRecordMinimumRequestCnaContainer) HasProblemTypes() bool {
	if o != nil && !IsNil(o.ProblemTypes) {
		return true
	}

	return false
}

// SetProblemTypes gets a reference to the given []GetCveRecordResponseContainersCnaProblemTypesInner and assigns it to the ProblemTypes field.
func (o *CveRecordMinimumRequestCnaContainer) SetProblemTypes(v []GetCveRecordResponseContainersCnaProblemTypesInner) {
	o.ProblemTypes = v
}

// GetProviderMetadata returns the ProviderMetadata field value if set, zero value otherwise.
func (o *CveRecordMinimumRequestCnaContainer) GetProviderMetadata() GetCveRecordResponseContainersCnaProviderMetadata {
	if o == nil || IsNil(o.ProviderMetadata) {
		var ret GetCveRecordResponseContainersCnaProviderMetadata
		return ret
	}
	return *o.ProviderMetadata
}

// GetProviderMetadataOk returns a tuple with the ProviderMetadata field value if set, nil otherwise
// and a boolean to check if the value has been set.
func (o *CveRecordMinimumRequestCnaContainer) GetProviderMetadataOk() (*GetCveRecordResponseContainersCnaProviderMetadata, bool) {
	if o == nil || IsNil(o.ProviderMetadata) {
		return nil, false
	}
	return o.ProviderMetadata, true
}

// HasProviderMetadata returns a boolean if a field has been set.
func (o *CveRecordMinimumRequestCnaContainer) HasProviderMetadata() bool {
	if o != nil && !IsNil(o.ProviderMetadata) {
		return true
	}

	return false
}

// SetProviderMetadata gets a reference to the given GetCveRecordResponseContainersCnaProviderMetadata and assigns it to the ProviderMetadata field.
func (o *CveRecordMinimumRequestCnaContainer) SetProviderMetadata(v GetCveRecordResponseContainersCnaProviderMetadata) {
	o.ProviderMetadata = &v
}

// GetReferences returns the References field value
func (o *CveRecordMinimumRequestCnaContainer) GetReferences() []GetCveRecordResponseContainersCnaReferencesInner {
	if o == nil {
		var ret []GetCveRecordResponseContainersCnaReferencesInner
		return ret
	}

	return o.References
}

// GetReferencesOk returns a tuple with the References field value
// and a boolean to check if the value has been set.
func (o *CveRecordMinimumRequestCnaContainer) GetReferencesOk() ([]GetCveRecordResponseContainersCnaReferencesInner, bool) {
	if o == nil {
		return nil, false
	}
	return o.References, true
}

// SetReferences sets field value
func (o *CveRecordMinimumRequestCnaContainer) SetReferences(v []GetCveRecordResponseContainersCnaReferencesInner) {
	o.References = v
}

func (o CveRecordMinimumRequestCnaContainer) MarshalJSON() ([]byte, error) {
	toSerialize,err := o.ToMap()
	if err != nil {
		return []byte{}, err
	}
	return json.Marshal(toSerialize)
}

func (o CveRecordMinimumRequestCnaContainer) ToMap() (map[string]interface{}, error) {
	toSerialize := map[string]interface{}{}
	toSerialize["affected"] = o.Affected
	toSerialize["descriptions"] = o.Descriptions
	if !IsNil(o.ProblemTypes) {
		toSerialize["problemTypes"] = o.ProblemTypes
	}
	if !IsNil(o.ProviderMetadata) {
		toSerialize["providerMetadata"] = o.ProviderMetadata
	}
	toSerialize["references"] = o.References
	return toSerialize, nil
}

type NullableCveRecordMinimumRequestCnaContainer struct {
	value *CveRecordMinimumRequestCnaContainer
	isSet bool
}

func (v NullableCveRecordMinimumRequestCnaContainer) Get() *CveRecordMinimumRequestCnaContainer {
	return v.value
}

func (v *NullableCveRecordMinimumRequestCnaContainer) Set(val *CveRecordMinimumRequestCnaContainer) {
	v.value = val
	v.isSet = true
}

func (v NullableCveRecordMinimumRequestCnaContainer) IsSet() bool {
	return v.isSet
}

func (v *NullableCveRecordMinimumRequestCnaContainer) Unset() {
	v.value = nil
	v.isSet = false
}

func NewNullableCveRecordMinimumRequestCnaContainer(val *CveRecordMinimumRequestCnaContainer) *NullableCveRecordMinimumRequestCnaContainer {
	return &NullableCveRecordMinimumRequestCnaContainer{value: val, isSet: true}
}

func (v NullableCveRecordMinimumRequestCnaContainer) MarshalJSON() ([]byte, error) {
	return json.Marshal(v.value)
}

func (v *NullableCveRecordMinimumRequestCnaContainer) UnmarshalJSON(src []byte) error {
	v.isSet = true
	return json.Unmarshal(src, &v.value)
}


